﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MyISO.Model.Global;

namespace MyISO.Model.Client
{
    /// <summary>
    /// Cette classe fournit les propriétés nécessaires à l'application du pattern MVVM.
    /// This class provides the required properties for the MVVM pattern.
    /// </summary>
    /// <author>
    /// <name>
    /// Grégory MARTIN
    /// </name>
    /// <website>
    /// http://www.gmdevelopment.info
    /// </website>
    /// </author>
    /// <seealso cref="MyISO.Model.Global.ISO9660"/>
    class ISO9660Client : GalaSoft.MvvmLight.ViewModelBase
    {
        private ISO9660 _ISO;

        internal ISO9660 ISO
        {
            get { return _ISO; }
            set
            {
                _ISO = value;
                //RaisePropertyChanged(() => ISO);
            }
        }

        public bool InProgress
        {
            get { return this._ISO.InProgress; }
            set
            {
                this._ISO.InProgress = value;
                RaisePropertyChanged(() => InProgress);
            }
        }

        public string Path
        {
            get { return this._ISO.Path; }
            set
            {
                this._ISO.Path = value;
                RaisePropertyChanged(() => Path);
            }
        }

        public string ISOPath
        {
            get
            {
                return this._ISO.ISOPath;
            }
            set
            {
                this._ISO.ISOPath = value;
                RaisePropertyChanged(() => ISOPath);
            }
        }

        public string VolumeName
        {
            get
            {
                return this._ISO.VolumeName;
            }

            set
            {
                this._ISO.VolumeName = value;
                RaisePropertyChanged(() => VolumeName);
            }
        }

        public ISO9660Client()
        {
            this._ISO = new ISO9660();
        }

        private AsyncCallback _Callback;

        public AsyncCallback Callback
        {
            get { return _Callback = _Callback ?? new AsyncCallback(CreationFinished); }
            set { _Callback = value; }
        }

        private void CreationFinished(IAsyncResult ar)
        {
            this.InProgress = false;
        }

        public void StartCreation(AsyncCallback cb, bool IsBootable, string BootFile)
        {
            this._ISO.StartCreation(cb, IsBootable, BootFile);
        }
    }
}
