﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;

namespace MyISO.ViewModel
{
    /// <summary>
    /// This class is a Converter so it implements IValueConverter.
    /// The Convert and ConvertBack method simply negates the value.
    /// </summary>
    /// <see cref="System.Windows.Data.IValueConverter"/>
    [ValueConversion(typeof(bool), typeof(bool))]
    public class NegateBooleanConverter : IValueConverter
    {
        /// <summary>
        /// Nie la valeur booléenne value.
        /// Negates the boolean value.
        /// </summary>
        /// <param name="value">(true|false)</param>
        /// <param name="targetType"></param>
        /// <param name="parameter"></param>
        /// <param name="culture"></param>
        /// <returns>!value</returns>
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return !(bool)value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return !(bool)value;
        }
    }
}